////    $RCSfile: lab30.cpp,v $
////    $Date: 2011/09/26 22:49:20 $
////.BlockStart
typedef long BookId;
typedef long PatronId;
typedef float Money;		// Placeholder
typedef float Date;		//   (ditto)
////.BlockEnd

////.BlockStart
// Classes which use CheckOutPolicy may want to refer to
// a given instance of this class, or may want to copy the
// information into themselves.  This is an implementation
// issue and isn't important as far as the design is
// concerned.
struct CheckOutPolicy {
    int daysBeforeDue;		// Referenced by CheckOut
    Money finePerDay;		// Referenced by Fine
};
////.BlockEnd

////.BlockStart
// This is a "given".  It's only here to illustrate a point.
template <class T>
class ListOf {
    // ...
  public:
    void Add(T value);
    void Del(T value);
    T First();		// Really iterators, but don't
    T Last();		// learn those until Chapter 4
    T Next();
    T Prev();
};
////.BlockEnd

////.BlockStart
// Remember: a more generic interface would have "Media" as a
// base class, with Book, LP, Video, and so on, as subclasses.
class Book {
    ListOf<BookId> bookIds;	// Lots of books with the same info?
    char *author, *title, *isbn;
    CheckOutPolicy &cop;	// Business policy...
  public:
    // Constructors and destructors will be needed...
};
////.BlockEnd

////.BlockStart
class Patron {
    PatronId custId;		// customer id, so to speak
    char *name, *addr, *city;	// personal information
    CheckOutPolicy &cop;	// Business policy...
  public:
    // Constructors and destructors will be needed...
};
////.BlockEnd

////.BlockStart
// Created every time a book is checked out.  The list
// of all CheckOuts is scanned once per day and over-due
// books become "Fine" objects instead, and are moved to
// a separate list.  Note that a Fine _is a_ CheckOut, but
// with additional detail.
class CheckOut {
    Date    dueBack;		// copied policy
    Patron* custId;		// could be PatronId
    Book*   bookId;		// could be BookId
  public:
    CheckOut(BookId b, PatronId p);
};
////.BlockEnd

////.BlockStart
// Need to keep a list of these in order to record payments.
class Payment {
    Date  whenPaid;
    Money amtPaid;
};
////.BlockEnd

////.BlockStart
class Fine : public CheckOut {
    Money feePerDay;		// copied policy
    Money owed;			// how much?
    Date  whenReturned;		// actual return date
    ListOf<Payment> pymts;
  public:
    Fine(const CheckOut &co);
};
////.BlockEnd

////.BlockStart
// Objects used...
ListOf<Book*>   books;
ListOf<Book*>   lostBooks;	// Another solution is a flag in the Book
ListOf<Patron*> patrons;

// Books are deleted from "checkOuts" when returned.
// If overdue, they are moved to "fines".
ListOf<CheckOut*> checkOuts;
ListOf<Fine*>     fines;
////.BlockEnd
